/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { AverageTrueRangeIndicatorStrategy } from "./AverageTrueRangeIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core/ES2015/type";
/**
 * @hidden
 */
export class AverageTrueRangeIndicator extends StrategyBasedIndicator {
    get_p4() {
        return new AverageTrueRangeIndicatorStrategy();
    }
    get p4() {
        return this.get_p4();
    }
    get_qh() {
        return AverageTrueRangeIndicator.$;
    }
    get qh() {
        return this.get_qh();
    }
    get qp() {
        return typeGetValue(this.c(AverageTrueRangeIndicator.qq));
    }
    set qp(a) {
        this.h(AverageTrueRangeIndicator.qq, a);
    }
    qa() {
        return this.qp;
    }
    qj(a) {
        this.qp = a;
    }
}
AverageTrueRangeIndicator.$t = markType(AverageTrueRangeIndicator, 'AverageTrueRangeIndicator', StrategyBasedIndicator.$);
AverageTrueRangeIndicator.qq = StrategyBasedIndicator.qm(14, AverageTrueRangeIndicator.$);
//# sourceMappingURL=AverageTrueRangeIndicator.js.map