/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { BollingerBandWidthIndicatorStrategy } from "./BollingerBandWidthIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core/ES2015/type";
/**
 * @hidden
 */
export class BollingerBandWidthIndicator extends StrategyBasedIndicator {
    get_p4() {
        return new BollingerBandWidthIndicatorStrategy();
    }
    get p4() {
        return this.get_p4();
    }
    get_qh() {
        return BollingerBandWidthIndicator.$;
    }
    get qh() {
        return this.get_qh();
    }
    get qq() {
        return typeGetValue(this.c(BollingerBandWidthIndicator.qt));
    }
    set qq(a) {
        this.h(BollingerBandWidthIndicator.qt, a);
    }
    qa() {
        return this.qq;
    }
    get qp() {
        return this.c(BollingerBandWidthIndicator.qs);
    }
    set qp(a) {
        this.h(BollingerBandWidthIndicator.qs, a);
    }
    p8() {
        return this.qp;
    }
}
BollingerBandWidthIndicator.$t = markType(BollingerBandWidthIndicator, 'BollingerBandWidthIndicator', StrategyBasedIndicator.$);
BollingerBandWidthIndicator.qt = StrategyBasedIndicator.qm(20, BollingerBandWidthIndicator.$);
BollingerBandWidthIndicator.qs = StrategyBasedIndicator.ql(2, BollingerBandWidthIndicator.$);
//# sourceMappingURL=BollingerBandWidthIndicator.js.map