/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod_$type } from "./IShortPeriodLongPeriod";
import { PercentageVolumeOscillatorIndicatorStrategy } from "./PercentageVolumeOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core/ES2015/type";
/**
 * @hidden
 */
export class PercentageVolumeOscillatorIndicator extends StrategyBasedIndicator {
    get_p4() {
        return new PercentageVolumeOscillatorIndicatorStrategy();
    }
    get p4() {
        return this.get_p4();
    }
    get_qh() {
        return PercentageVolumeOscillatorIndicator.$;
    }
    get qh() {
        return this.get_qh();
    }
    get shortPeriod() {
        return typeGetValue(this.c(PercentageVolumeOscillatorIndicator.qq));
    }
    set shortPeriod(a) {
        this.h(PercentageVolumeOscillatorIndicator.qq, a);
    }
    qc() {
        return this.shortPeriod;
    }
    get longPeriod() {
        return typeGetValue(this.c(PercentageVolumeOscillatorIndicator.qp));
    }
    set longPeriod(a) {
        this.h(PercentageVolumeOscillatorIndicator.qp, a);
    }
    p9() {
        return this.longPeriod;
    }
}
PercentageVolumeOscillatorIndicator.$t = markType(PercentageVolumeOscillatorIndicator, 'PercentageVolumeOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
PercentageVolumeOscillatorIndicator.qq = StrategyBasedIndicator.qo(10, PercentageVolumeOscillatorIndicator.$);
PercentageVolumeOscillatorIndicator.qp = StrategyBasedIndicator.qk(30, PercentageVolumeOscillatorIndicator.$);
//# sourceMappingURL=PercentageVolumeOscillatorIndicator.js.map