import { StraightNumericAxisBase } from "./StraightNumericAxisBase";
import { IScaler } from "./IScaler";
import { AxisOrientation } from "./AxisOrientation";
import { AxisView } from "./AxisView";
import { Type, IList$1 } from "igniteui-angular-core/ES5/type";
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { NumericAxisRenderer } from "./NumericAxisRenderer";
import { ScalerParams } from "./ScalerParams";
import { NumericScaler } from "./NumericScaler";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { NumericAxisRenderingParameters } from "./NumericAxisRenderingParameters";
import { StraightNumericAxisBaseView } from "./StraightNumericAxisBaseView";
/**
 * @hidden
 */
export declare class NumericXAxis extends StraightNumericAxisBase implements IScaler {
    static $t: Type;
    a1(): AxisView;
    gm(a: AxisView): void;
    lo: NumericXAxisView;
    constructor();
    as(): AxisLabelPanelBase;
    i6(): NumericAxisRenderer;
    dt(a: number, b: ScalerParams): number;
    dw(a: number, b: ScalerParams): number;
    gh(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    gg(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    gi(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    lp(a: number, b: number): void;
    i9(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    protected g1(a: boolean): void;
    protected hb(a: Rect, b: Rect): void;
    protected get_az(): AxisOrientation;
    readonly az: AxisOrientation;
    jb(): NumericScaler;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    readonly j$a: boolean;
}
/**
 * @hidden
 */
export declare class NumericXAxisView extends StraightNumericAxisBaseView {
    static $t: Type;
    protected bh: NumericXAxis;
    constructor(a: NumericXAxis);
}
