import { ShapeSeriesBase } from "./ShapeSeriesBase";
import { ShapeAxisInfoCache } from "./ShapeAxisInfoCache";
import { StyleSelector } from "./StyleSelector";
import { Style } from "igniteui-angular-core/ES5/Style";
import { MarkerType } from "./MarkerType";
import { DataTemplate } from "igniteui-angular-core/ES5/DataTemplate";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { CollisionAvoidanceType } from "./CollisionAvoidanceType";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { Type, Point } from "igniteui-angular-core/ES5/type";
import { SeriesView } from "./SeriesView";
import { OwnedPoint } from "./OwnedPoint";
import { ShapeSeriesViewBase } from "./ShapeSeriesViewBase";
import { DataContext } from "igniteui-angular-core/ES5/DataContext";
import { Marker } from "./Marker";
import { IDictionary$2 } from "igniteui-angular-core/ES5/IDictionary$2";
import { HashPool$2 } from "igniteui-angular-core/ES5/HashPool$2";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { FrameworkElement } from "igniteui-angular-core/ES5/FrameworkElement";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { Size } from "igniteui-angular-core/ES5/Size";
import { PathGeometry } from "igniteui-angular-core/ES5/PathGeometry";
import { PointCollection } from "igniteui-angular-core/ES5/PointCollection";
import { RenderingContext } from "igniteui-angular-core/ES5/RenderingContext";
/**
 * @hidden
 */
export declare class ScatterPolygonSeries extends ShapeSeriesBase {
    static $t: Type;
    constructor();
    protected l9(): boolean;
    protected mq(a: SeriesView): void;
    private m9;
    protected bf(): SeriesView;
    im(a: SeriesView): void;
    m6: ScatterPolygonSeriesView;
    m7: ShapeAxisInfoCache;
    private static n3;
    private m4;
    private m5;
    protected get_hasMarkers(): boolean;
    ky(): Brush;
    kz(): Brush;
    jr(): DataTemplate;
    m8: StyleSelector;
    n5: Style;
    m3: MarkerType;
    nn: DataTemplate;
    nm: DataTemplate;
    n1: Brush;
    nz: Brush;
    n2: Brush;
    n0: Brush;
    n4: Style;
    m2: CollisionAvoidanceType;
    protected jg(): void;
    protected is(a: any, b: string, c: any, d: any): void;
    ar(a: Point, b: boolean): DataContext;
    nl(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    ch(a: List$1<SeriesPointOfInterest>, b: boolean, c: number): boolean;
    m1(a: ScatterPolygonSeriesView, b: HashPool$2<any, Marker>, c: Point[], d: Rect, e: Rect): Point[];
    m0(a: HashPool$2<any, Marker>, b: number[]): number[];
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterPolygonSeriesView extends ShapeSeriesViewBase {
    static $t: Type;
    constructor(a: ScatterPolygonSeries);
    ap(): void;
    readonly c4: NumericMarkerManager;
    protected dj(a: IDictionary$2<any, OwnedPoint>): void;
    protected cy(): Point[];
    protected cx(): number[];
    private c0;
    private cz;
    private c5;
    private c3;
    protected cu(a: number, b: List$1<PointCollection>): PathGeometry;
    protected cc(a: FrameworkElement, b: any): void;
    protected ca(a: FrameworkElement, b: PathGeometry): void;
    private c7;
    c6: HashPool$2<any, Marker>;
    dd(a: (arg1: Marker) => void): void;
    df(a: HashPool$2<any, Marker>): void;
    c2(): Marker;
    protected c8: List$1<Marker>;
    dh(a: Marker): void;
    dg(a: Marker): void;
    di(a: Marker): void;
    dk(a: boolean): void;
    protected be(a: any, b: number): void;
    protected bf(a: any, b: number): void;
    protected a2(a: RenderingContext, b: boolean): void;
    dc(): void;
    da(): void;
    db(): void;
    c9(a: string): void;
    de(): void;
    private dl;
    dm(a: Marker): Size;
    c1(a: Point): Marker;
    ai(a: any): void;
    getDefaultTooltipTemplate(): string;
}
