import { ScatterBase } from "./ScatterBase";
import { IScaleLegendSeries } from "igniteui-angular-core/ES2015/IScaleLegendSeries";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { IFastItemColumn$1 } from "igniteui-angular-core/ES2015/IFastItemColumn$1";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { UIElement } from "igniteui-angular-core/ES2015/UIElement";
import { Type } from "igniteui-angular-core/ES2015/type";
import { SizeScale } from "./SizeScale";
import { BrushScale } from "./BrushScale";
import { SeriesView } from "./SeriesView";
import { ScatterFrame } from "./ScatterFrame";
import { IChartLegend } from "igniteui-angular-core/ES2015/IChartLegend";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { ScatterBaseView } from "./ScatterBaseView";
import { FastItemsSourceEventAction } from "igniteui-angular-core/ES2015/FastItemsSourceEventAction";
import { Marker } from "./Marker";
import { BrushSelectionMode } from "./BrushSelectionMode";
import { MarkerManagerBase } from "./MarkerManagerBase";
/**
 * @hidden
 */
export declare class BubbleSeries extends ScatterBase implements IScaleLegendSeries {
    static $t: Type;
    protected bf(): SeriesView;
    im(a: SeriesView): void;
    oq: BubbleSeriesView;
    constructor();
    private po;
    private pn;
    isAttachedTo(a: IChartLegend): boolean;
    protected ci(): boolean;
    protected h0(a: (arg1: any) => void): void;
    readonly ow: IFastItemColumn$1<number>;
    oz: List$1<UIElement>;
    private pm;
    readonly legendReady: boolean;
    readonly minScaleText: string;
    readonly maxScaleText: string;
    forScaleColors(a: (arg1: Brush, arg2: number) => void): boolean;
    pa: string;
    oy: IFastItemColumn$1<number>;
    private ou;
    or: SizeScale;
    o7: string;
    private ot;
    ox: IFastItemColumn$1<any>;
    o3: string;
    op: BrushScale;
    private os;
    ov: IFastItemColumn$1<number>;
    nq(a: ScatterBaseView, b: ScatterFrame, c: number, d: Rect, e: Rect): void;
    nu(a: ScatterFrame, b: ScatterBaseView): void;
    private pe;
    static o0(a: number, b: number, c: number, d: number, e: number): number;
    static o1(a: number, b: number, c: number, d: number, logBase_: number, e: number): number;
    dv(a: Rect, b: Rect, c: SeriesView): boolean;
    protected na(a: string, b: FastItemsSourceEventAction): boolean;
    private pd;
    protected hs(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    h6(): void;
    ib(): void;
    protected is(a: any, b: string, c: any, d: any): void;
    pg(a: List$1<Marker>, b: List$1<number>, c: Rect, d: boolean): void;
    pf(a: List$1<Marker>): void;
    protected get_cy(): boolean;
    readonly actualMarkerBrush: Brush;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CustomPaletteBrushScale extends BrushScale {
    static $t: Type;
    constructor();
    brushSelectionMode: BrushSelectionMode;
    getBrush1(a: number, b: number): Brush;
    protected get_isReady(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class BubbleSeriesView extends ScatterBaseView {
    static $t: Type;
    protected da: BubbleSeries;
    constructor(a: BubbleSeries);
    ap(): void;
    protected cq(): MarkerManagerBase;
    dc(): void;
    dd(): void;
    db(): void;
    getDefaultTooltipTemplate(): string;
}
