import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { AxisOrientation } from "./AxisOrientation";
import { AxisView } from "./AxisView";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { Point, IList$1, Type } from "igniteui-angular-core/ES2015/type";
import { ScalerParams } from "./ScalerParams";
import { CategoryMode } from "./CategoryMode";
import { SeriesViewer } from "./SeriesViewer";
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
/**
 * @hidden
 */
export declare class CategoryYAxis extends CategoryAxisBase {
    static $t: Type;
    a1(): AxisView;
    gm(a: AxisView): void;
    kq: CategoryYAxisView;
    protected get_ce(): boolean;
    ds(): number;
    kn(a: Point, b: boolean, c: number): Rect;
    protected kp(a: IList$1<number[]>): number[][];
    gg(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    constructor();
    static readonly k8: DependencyProperty;
    kw: number;
    private kr;
    ks: number;
    d4(): number;
    static readonly k9: DependencyProperty;
    kx: number;
    private kt;
    ku: number;
    private kz;
    k1: number;
    private ky;
    k0: number;
    dt(a: number, b: ScalerParams): number;
    private kv;
    dw(a: number, b: ScalerParams): number;
    dx(a: number, b: ScalerParams, c: CategoryMode): number;
    getUnscaledValue3(a: number, b: Rect, c: Rect, d: CategoryMode): number;
    k7(a: number, b: number): void;
    as(): AxisLabelPanelBase;
    dg(): number;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    jk(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    k6(a: any): void;
    cm(): boolean;
    jb(a: SeriesViewer): boolean;
    protected g1(a: boolean): void;
    protected get_az(): AxisOrientation;
    readonly az: AxisOrientation;
    readonly isVertical: boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    readonly j$a: boolean;
}
/**
 * @hidden
 */
export declare class CategoryYAxisView extends CategoryAxisBaseView {
    static $t: Type;
    protected bf: CategoryYAxis;
    constructor(a: CategoryYAxis);
}
