/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { PolarLineSeriesBase } from "./PolarLineSeriesBase";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { Type, markType } from "igniteui-angular-core/ES2015/type";
import { PropertyMetadata } from "igniteui-angular-core/ES2015/PropertyMetadata";
import { PolarLineSeriesBaseView } from "./PolarLineSeriesBaseView";
import { Path } from "igniteui-angular-core/ES2015/Path";
import { PathGeometry } from "igniteui-angular-core/ES2015/PathGeometry";
import { PathFigure } from "igniteui-angular-core/ES2015/PathFigure";
import { Extensions } from "igniteui-angular-core/ES2015/Extensions";
import { Numeric } from "igniteui-angular-core/ES2015/Numeric";
import { Color } from "igniteui-angular-core/ES2015/Color";
/**
 * @hidden
 */
export class PolarSplineSeries extends PolarLineSeriesBase {
    constructor() {
        super();
        this.ab = PolarSplineSeries.$;
    }
    bf() {
        return new PolarSplineSeriesView(this);
    }
    im(a) {
        super.im(a);
        this.o5 = a;
    }
    is(a, b, c, d) {
        super.is(a, b, c, d);
        switch (b) {
            case PolarSplineSeries.$$p[0]:
                this.i5(false);
                break;
        }
    }
    o3(a) {
        let b = a;
        b.c0();
    }
    o4(a, b) {
        this.o3(b);
        let c = b;
        c.c1(a.m, this.o6);
    }
}
PolarSplineSeries.$t = markType(PolarSplineSeries, 'PolarSplineSeries', PolarLineSeriesBase.$);
Type.dep(DependencyProperty, PropertyMetadata, PolarSplineSeries, 'raisePropertyChanged', ['Stiffness:o6:o8', [1, 0.5]]);
/**
 * @hidden
 */
export class PolarSplineSeriesView extends PolarLineSeriesBaseView {
    constructor(a) {
        super(a);
        this.cz = null;
        this.c2 = ((() => {
            let $ret = new Path();
            $ret.aj = new PathGeometry();
            return $ret;
        })());
        this.cz = a;
    }
    ap() {
        super.ap();
        let a = new PathGeometry();
        a.b.add(((() => {
            let $ret = new PathFigure();
            return $ret;
        })()));
        this.c2.aj = a;
    }
    c0() {
        Extensions.e(this.c2.aj);
        this.an();
    }
    c1(a, b) {
        this.c2.aj.b = Numeric.h(a.count, (c) => a._inner[c].x, (c) => a._inner[c].y, b);
        this.an();
    }
    a8() {
        super.a8();
        this.c2._stroke = this.e.kv;
        this.c2.ac = this.e.ev;
        this.c2.ai = this.e.k3;
        this.c2.ad = this.e.k4;
    }
    a9() {
        super.a9();
        let a = this.bl();
        this.c2._stroke = a;
        this.c2.ac = this.e.ev + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        a.s(this.c2);
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.c2, "polarShape", ["Main"]);
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.k2 = a;
        this.e.es = 3;
        this.e.et = 1;
        this.e.eu = 4;
        this.e.dt = false;
    }
}
PolarSplineSeriesView.$t = markType(PolarSplineSeriesView, 'PolarSplineSeriesView', PolarLineSeriesBaseView.$);
//# sourceMappingURL=PolarSplineSeries_combined.js.map