import { Series } from "./Series";
import { IFastItemColumn$1 } from "igniteui-angular-core/ES2015/IFastItemColumn$1";
import { IEnumerable, Type } from "igniteui-angular-core/ES2015/type";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemsSource } from "igniteui-angular-core/ES2015/IFastItemsSource";
import { TriangulationStatusEventArgs } from "igniteui-angular-core/ES2015/TriangulationStatusEventArgs";
import { Axis } from "./Axis";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { SeriesView } from "./SeriesView";
import { FastItemsSourceEventAction } from "igniteui-angular-core/ES2015/FastItemsSourceEventAction";
import { AxisRange } from "./AxisRange";
/**
 * @hidden
 */
export declare abstract class ScatterTriangulationSeries extends Series {
    static $t: Type;
    hn(): void;
    mq: string;
    mu: string;
    private lz;
    protected l5: IFastItemColumn$1<number>;
    private l0;
    protected l6: IFastItemColumn$1<number>;
    ls: NumericXAxis;
    lt: NumericYAxis;
    private l8;
    i6(a: boolean): void;
    private my;
    private mw;
    private lv;
    triangulationStatusChanged: (sender: any, args: TriangulationStatusEventArgs) => void;
    private mz;
    protected l1(a: IFastItemsSource, b: string): IFastItemColumn$1<number>;
    protected is(a: any, b: string, c: any, d: any): void;
    ma(a: any): boolean;
    l9(a: any): boolean;
    dv(a: Rect, b: Rect, c: SeriesView): boolean;
    private mx;
    private mb;
    h4(): void;
    protected hs(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    an(a: Axis): AxisRange;
    protected jl(a: Rect, b: Rect): void;
    protected jk(a: Rect, b: Rect): void;
    trianglesSource: IEnumerable;
    l7: IFastItemsSource;
    mi: string;
    mk: string;
    mm: string;
    private lw;
    protected l2: IFastItemColumn$1<number>;
    private lx;
    protected l3: IFastItemColumn$1<number>;
    private ly;
    protected l4: IFastItemColumn$1<number>;
    protected get_c5(): boolean;
    static $$p: string[];
}
