/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { SlowStochasticOscillatorIndicatorStrategy } from "./SlowStochasticOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core/ES2015/type";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
/**
 * @hidden
 */
export class SlowStochasticOscillatorIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
        this.trendLineBrush = ((() => {
            let $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        this.trendLineType = 10;
        this.trendLinePeriod = 3;
    }
    get_p4() {
        return new SlowStochasticOscillatorIndicatorStrategy();
    }
    get p4() {
        return this.get_p4();
    }
    get_qh() {
        return SlowStochasticOscillatorIndicator.$;
    }
    get qh() {
        return this.get_qh();
    }
    get qp() {
        return typeGetValue(this.c(SlowStochasticOscillatorIndicator.qq));
    }
    set qp(a) {
        this.h(SlowStochasticOscillatorIndicator.qq, a);
    }
    qa() {
        return this.qp;
    }
    qj(a) {
        this.qp = a;
    }
}
SlowStochasticOscillatorIndicator.$t = markType(SlowStochasticOscillatorIndicator, 'SlowStochasticOscillatorIndicator', StrategyBasedIndicator.$);
SlowStochasticOscillatorIndicator.qq = StrategyBasedIndicator.qm(14, SlowStochasticOscillatorIndicator.$);
//# sourceMappingURL=SlowStochasticOscillatorIndicator.js.map