import * as tslib_1 from "tslib";
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { IgxFinancialLegendComponent } from './igx-financial-legend-component';
import { TypeRegistrar } from "igniteui-angular-core/ES5/type";
import { LegendTemplates } from './LegendTemplates';
import { FinancialLegend } from './FinancialLegend';
var IgxFinancialLegendModule = /** @class */ (function () {
    function IgxFinancialLegendModule() {
        TypeRegistrar.register("FinancialLegend", FinancialLegend.$type);
        TypeRegistrar.register("LegendTemplates", LegendTemplates.$type);
    }
    IgxFinancialLegendModule = tslib_1.__decorate([
        NgModule({
            imports: [
                CommonModule,
            ],
            declarations: [
                IgxFinancialLegendComponent
            ],
            exports: [
                IgxFinancialLegendComponent
            ]
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxFinancialLegendModule);
    return IgxFinancialLegendModule;
}());
export { IgxFinancialLegendModule };
//# sourceMappingURL=igx-financial-legend-module.js.map